// Copyright (C) 2002 Takeshi Morimoto <morimoto@takopen.cs.uec.ac.jp>
// All rights reserved.

/**
 * CopyRight (C) 2005 Bam Rescue Simulation Team.All rights resserved.
 *
 * Hamid Mohammadi <hmohammadi110@gmail.com>
 * Hamed Shahbazi  <demahopilot@yahoo.com>
 * Behrooz Shahgholi <shahgholi@eng.ui.ac.ir>
 *
 */

package bam;

import java.util.*;
import java.net.*;
import yab.agent.*;
import yab.agent.object.*;

public class AmbulanceCenterAgent extends AbstractAmbulanceCenterAgent {
    private String messageBuffer;
    private int MaxLenghtMessage;

    // Constructor of AmbulanceCenterAgent Class
    public AmbulanceCenterAgent(InetAddress address, int port) {
        super(address, port);
        Initialize();
    }


    protected void Initialize() {

        messageBuffer = new String("!");
        MaxLenghtMessage = 255;

    }

    private void sendBufferData() {
        if (messageBuffer.length() > 1) {
            tell(messageBuffer);
            messageBuffer = "!";
        }
    }

    public void act() throws ActionCommandException {
        if (world.time() > 5 || world.time() % 3 == 2) {
            sendBufferData();
        }
        rest();
    }

    protected void hear(RealObject sender, String message) {

        //for loops!
        if (sender instanceof AmbulanceCenter) {
            return;
        }

        StringTokenizer strt = new StringTokenizer(message, "*");
        String str = strt.nextToken();
        if ((sender instanceof FireStation) || (sender instanceof PoliceOffice)) {
            if (str.equals("!")) {
                message = message.replace('!', '@');
                tell(message);
            }
        }
        if (sender instanceof AmbulanceTeam) {
            if ((message.length() + messageBuffer.length() + 1) >=
                MaxLenghtMessage) {
                tell(messageBuffer);
                messageBuffer = "!";
            }
            if (messageBuffer.length() != 0) {
                messageBuffer = messageBuffer.concat("*");
            }
            messageBuffer = messageBuffer.concat(message);

        }

    }
}
