// Copyright (C) 2002 Takeshi Morimoto <morimoto@takopen.cs.uec.ac.jp>
// All rights reserved.

/**
 * CopyRight (C) 2005 Bam Rescue Simulation Team.All rights resserved.
 *
 * Hamid Mohammadi <hmohammadi110@gmail.com>
 * Hamed Shahbazi  <demahopilot@yahoo.com>
 * Behrooz Shahgholi <shahgholi@eng.ui.ac.ir>
 *
 */

package yab.agent;

import java.net.*;
import yab.agent.*;
import yab.agent.object.*;
import yab.io.ProtocolConstants;
import bam.*;

public abstract class AbstractAmbulanceTeamAgent extends PlatoonAgent {
    protected AbstractAmbulanceTeamAgent(InetAddress address, int port) {
        super(ProtocolConstants.AGENT_TYPE_AMBULANCE_TEAM, address, port);
    }

    protected AmbulanceTeam self() {
        return (AmbulanceTeam) world.self;
    }

    public boolean underrescue = false;

    public Humanoid m_loadingInjured = null;

    public recordHuman loadedVictim = null;
    public recordHuman targetVictim = null;

    public Humanoid loadingInjured() {
        return m_loadingInjured;
    }

    protected boolean isLoadingInjured() {
        return m_loadingInjured != null;
    }

    protected void checkLoadingInjured() {
        if (loadingInjured() instanceof Humanoid
            && loadingInjured().position() != self()) {
            m_loadingInjured = null;
        }
    }

    protected void prepareForAct() {
        super.prepareForAct();
        checkLoadingInjured();
    }

    protected void rescue(Humanoid target) throws ActionCommandException {
        socket().akRescue(self().id, target.id);

        // this.underrescue = true;


        throw new ActionCommandException();
    }

    protected void load(Humanoid target) throws ActionCommandException {
        socket().akLoad(self().id, target.id);
        this.underrescue = true;
        target.loading();
        m_loadingInjured = target;
        throw new ActionCommandException();
    }

    protected void unload() throws ActionCommandException {
        socket().akUnload(self().id);
        this.underrescue = false;
        m_loadingInjured = null;
        targetVictim = null;
        loadedVictim = null;
        throw new ActionCommandException();
    }
}
