// Copyright (C) 2002 Takeshi Morimoto <morimoto@takopen.cs.uec.ac.jp>
// All rights reserved.

/**
 * CopyRight (C) 2005 Bam Rescue Simulation Team.All rights resserved.
 *
 * Hamid Mohammadi <hmohammadi110@gmail.com>
 * Hamed Shahbazi  <demahopilot@yahoo.com>
 * Behrooz Shahgholi <shahgholi@eng.ui.ac.ir>
 *
 */

package yab.agent;

import java.util.*;
import yab.agent.Util.*;
import yab.agent.object.*;

public class Route {
    public final MotionlessObject end;
    public final float cost;
    private Route m_previous;

    /*public*/Route previous() {
        return m_previous;
    }

    /*public*/ void setPrevious(Route previous) {
        m_previous = previous;
    }

    public Route(MotionlessObject end) {
        this(end, 0, null);
    }

    private Route(MotionlessObject end, float cost, Route previous) {
        this.end = end;
        this.cost = cost;
        m_previous = previous;
    }

    public Route expandedRoute(MotionlessObject next,
                               Router.CostFunction costFunc, int distance) {
        return new Route(next, cost + costFunc.cost(end, next, distance), this);
    }

    public int size() {
        int result = 0;
        for (Route rt = this; rt != null; rt = rt.previous()) {
            result++;
        }
        return result;
    }

    public int[] toIDs() {
        int i = size();
        int[] ids = new int[i];
        for (Route rt = this; rt != null; rt = rt.previous()) {
            ids[--i] = rt.end.id;
        }
        return ids;
    }

    public String toString() {
        //return Util.classBaseName(this) + "(cost:" + cost + ",end:" +end+")";
        String str = "";
        for (Route rt = this; rt != null; rt = rt.previous()) {
            str = rt.end + "," + str;
        }
        return str;
    }
}
