// Copyright (C) 2002 Takeshi Morimoto <morimoto@takopen.cs.uec.ac.jp>
// All rights reserved.

/**
 * CopyRight (C) 2005 Bam Rescue Simulation Team.All rights resserved.
 *
 * Hamid Mohammadi <hmohammadi110@gmail.com>
 * Hamed Shahbazi  <demahopilot@yahoo.com>
 * Behrooz Shahgholi <shahgholi@eng.ui.ac.ir>
 *
 */

package yab.agent.object;

import yab.agent.DisasterSpace;
import yab.io.object.*;

public abstract class Humanoid extends MovingObject {
    public Humanoid(int id, BaseHumanoid object, DisasterSpace world) {
        super(id, object, world);
    }

    private BaseHumanoid obj() {
        return (BaseHumanoid) object;
    }

    private int priority = 0;
    public int hp() {
        return obj().hp();
    }

    public int damage() {
        return obj().damage();
    }

    public int buriedness() {
        return obj().buriedness();
    }

    public int priority() {
        if (hp() != 0) {
            return 100000 / hp();
        }
        return priority;
    }


    public int id() {
        return id;
    }

    public boolean loaded = false;

    public void loading() {
        loaded = true;
    }

    public void unloading() {
        loaded = false;
    }

}
