/**
 * CopyRight (C) 2005 Bam Rescue Simulation Team.All rights resserved.
 *
 * Hamid Mohammadi <hmohammadi110@gmail.com>
 * Hamed Shahbazi  <demahopilot@yahoo.com>
 * Behrooz Shahgholi <shahgholi@eng.ui.ac.ir>
 *
 */


package bam;

import java.net.*;
import yab.agent.*;
import yab.agent.object.*;
import java.util.*;

public class PoliceOfficeAgent extends AbstractPoliceOfficeAgent {
    private int MaxLengthMessage;
    List polices;
    private int numberOfZone;
    private ArrayList policeZones = new ArrayList();
    boolean zones[];
    int flag = 0;
    public PoliceOfficeAgent(InetAddress address, int port) {
        super(address, port);
        MaxLengthMessage = 255;
        messageBuffer = new String("!");
        polices = world.policeForces;
        numberOfZone = polices.size();
        zones = new boolean[numberOfZone];
        int Count = 0;
        for (Iterator it = world.policeForces.iterator(); it.hasNext(); ) {
            PoliceForce policeTemp = (PoliceForce) it.next();
            PoliceZone temp = new PoliceZone();
            temp.setPolice(policeTemp);
            policeZones.add(temp);
            zones[Count] = false;
            Count++;
        }

    }


    public void sendBufferData() {
        if (messageBuffer.length() > 1) {
            tell(messageBuffer);
            messageBuffer = null;
            messageBuffer = "!";
        }
    }

    public void informZone() {
        String str1 = "Zone: " + polices.size() + " ";
        String str2 = "Zone: " + polices.size() + " ";
        String str3 = "Zone: " + polices.size() + " ";
        for (Iterator it = policeZones.iterator(); it.hasNext(); ) {
            PoliceZone temp1 = (PoliceZone) it.next();
            if (!zones[temp1.getAssignZone() - 1]) {
                zones[temp1.getAssignZone() - 1] = true;
                temp1.selectZone();
            }
        }
        for (Iterator it = policeZones.iterator(); it.hasNext(); ) {
            PoliceZone temp1 = (PoliceZone) it.next();
            int min = 20;
            int minZone = 0;
            if (!temp1.isSelected()) {
                for (int i = 0; i < numberOfZone; i++) {
                    if (!zones[i]) {
                        if ((Math.abs((i + 1) - temp1.getAssignZone()) %
                             (numberOfZone / 2)) < min) {
                            min = Math.abs((i + 1) - temp1.getAssignZone()) %
                                  (numberOfZone / 2);
                            minZone = i + 1;
                        }
                    }
                }
                temp1.assignZone(minZone);
                temp1.selectZone();
                zones[minZone - 1] = true;
            }
        }
        int counter1 = 0;
        for (Iterator it = policeZones.iterator(); it.hasNext(); ) {
            PoliceZone policeTemp = (PoliceZone) it.next();
            if (counter1 <= 4) {
                str1 += policeTemp.getPoliceID() + "/" +
                        policeTemp.getAssignZone() + " ";
            } else
            if (counter1 <= 9) {
                str2 += policeTemp.getPoliceID() + "/" +
                        policeTemp.getAssignZone() + " ";
            } else
            if (counter1 <= 14) {
                str3 += policeTemp.getPoliceID() + "/" +
                        policeTemp.getAssignZone() + " ";
            }
            counter1++;
        }

        counter1--;

        tell(str1);
        tell(str2);
        if (counter1 >= 10) {
            tell(str3);
        }
    }


    private boolean checkForInform() {
        boolean temp = true;
        for (Iterator it = policeZones.iterator(); it.hasNext(); ) {
            PoliceZone temp2 = (PoliceZone) it.next();
            if (temp2.getAssignZone() == -1) {
                return false;
            }
        }
        return temp;
    }

    public void act() {
        if (world.time() == 2) {
            world.setRoadMax();
        }
        if (flag < 2) {
            if (checkForInform()) {
                informZone();
                flag++;
            }

        }
        if (world.time() > 5 || world.time() % 3 == 0) {
            sendBufferData();
        }
    }

    private String messageBuffer;
    protected void hear(RealObject sender, String message) {
        if (sender instanceof PoliceOffice) {
            return;
        }
        StringTokenizer st = new StringTokenizer(message);
        String command = st.nextToken();
        if (command.equals("zoneNow:")) {
            int hash = Integer.parseInt(st.nextToken());
            int tempZone = Integer.parseInt(st.nextToken());
            for (Iterator it = policeZones.iterator(); it.hasNext(); ) {
                PoliceZone temp1 = (PoliceZone) it.next();
                if (temp1.getPoliceID() == hash) {
                    temp1.assignZone(tempZone);
                    break;
                }
            }
            return;
        }

        if (sender instanceof FireStation || sender instanceof AmbulanceCenter) {
            StringTokenizer strt = new StringTokenizer(message, "*");
            String str = strt.nextToken();
            if (str.equals("!")) {
                message = message.replace('!', '@');
                tell(message);
            }
        }
        if (sender instanceof PoliceForce) {
            if ((messageBuffer.length() + message.length() + 1) >=
                MaxLengthMessage) {
                tell(messageBuffer);
                messageBuffer = null;
                messageBuffer = "!";
            }

            if (messageBuffer.length() != 0) {
                messageBuffer = messageBuffer.concat("*");
            }
            messageBuffer = messageBuffer.concat(message);

        }

    }

}
